#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <set>

using namespace std;

long long t;
long long n;
long long p[10000]; // Declaration of array p
set<long long> tests;

void dump() {
    t++;
    cerr << t << endl;
    ofstream outputFile(to_string(t / 10) + to_string(t % 10));
    outputFile << n << endl;
    tests.insert(n);
    outputFile.close();
}

long long pow(long long x, int b) {
    long long r = 1;
    while (b > 0) {
        if (b % 2 == 1)
            r *= x;
        x *= x;
        b /= 2;
    }
    return r;
}

bool valid(long long x, int b) {
    long double r = 1.0;
    for (int i = 1; i <= b; i++) {
        r *= x;
    }
    return r <= 1e18;
}

int main() {
    n = 6;
    dump();
    n = 100;
    dump();

    long long q = 2;
    int np = 0;
    while (q * q * q * q < 1000000000000000000) {
        bool prime = false;
        while (!prime) {
            prime = true;
            for (int j = 1; j <= np; j++) {
                if (q % p[j] == 0) {
                    prime = false;
                    break;
                }
            }
            if (prime) {
                np++;
                p[np] = q;
            }
            q++;
        }
    }

    for (int k = 2; k <= 23; k++) {
        n = pow(6, k);
        dump();
    }

    n = 999149867994650077;
    dump();
    n = 996005933628830459;
    dump();
    n = 998793267042793973;
    dump();
    n = 965530442656248397;
    dump();
    n = 1000000000000000000;
    dump();

    srand(293740);
    for (int z = 1; z <= 15; z++) {
        do {
            int k = rand() % 23 + 1;
            int i = rand() % np + 1;
            int j = rand() % np + 1;
            if (i != j && valid(p[i] * p[j], k) && !tests.count(pow(p[i] * p[j], k))) {
                n = pow(p[i] * p[j], k);
                dump();
                break;
            }
        } while (true);
    }

    for (int z = 1; z <= 8; z++) {
        int k = 2;
        do {
            int i = np - 10 + rand() % 10;
            int j = np - 10 + rand() % 10;
            if (i != j && valid(p[i] * p[j], k) && !tests.count(pow(p[i] * p[j], k))) {
                n = pow(p[i] * p[j], k);
                dump();
                break;
            }
        } while (true);
    }

    return 0;
}
